#if !defined(AFX_PD2_CHECKOUT_H__A8C3AFEF_76CA_4551_AC5A_75E1CCE41987__INCLUDED_)
#define AFX_PD2_CHECKOUT_H__A8C3AFEF_76CA_4551_AC5A_75E1CCE41987__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000
// PD2_Checkout.h : header file
//

#include "USBtestDlg.h"
#include "UM245R_Interface.h"

/////////////////////////////////////////////////////////////////////////////
// CPD2_Checkout dialog

class CPD2_Checkout : public CDialog
{
// Construction
public:
	void Update_Bit_List(unsigned int val);
	CPD2_Checkout(CWnd* pParent = NULL);   // standard constructor
	void Initialize_Dialog(void);
	void SetRegisterBit(int index, int bit, int setting);

	UM245R_Interface   *pUSB;
	CString				szControlReg;

	FILE				*fp;
	int					m_nFileIndex;
	CString				basefilename;

	UINT				m_nUpdateTimer;
	CWnd				*pADC1;
	CWnd				*pADC2;
	CWnd				*pDIGITS;

	typedef char *		label;
	label				szDIO[16];//array of labels (strings)

// Dialog Data
	//{{AFX_DATA(CPD2_Checkout)
	enum { IDD = IDD_PD2_CHECKOUT_DIALOG };
	CListBox	m_Bit_List;
	CListBox	m_ADC_Data_List;
	BOOL	m_bDAC_Selected;
	BOOL	m_bExt_Input_Selected;
	BOOL	m_bPhase_Det1_Selected;
	BOOL	m_bPhase_Det2_Selected;
	int		m_DAC1_Step_Direction;
	UINT	m_DAC_Step_Size;
	UINT	m_DAC_Setting;
	UINT	m_FPGA_DAC_Setting;
	UINT	m_FPGA_DAC_Step_Size;
	int		m_FPGA_DAC_Direction;
	UINT	m_MULT_DAC_Setting;
	UINT	m_MULT_DAC_Step_Size;
	int		m_MULT_DAC_Direction;
	UINT	m_ADC1_Reading;
	UINT	m_ADC2_Reading;
	float	m_fltADC1_Volts_In;
	float	m_fltADC2_Volts_In;
	CString	m_szFull_Filename;
	BOOL	m_nDO1;
	BOOL	m_nDO2;
	BOOL	m_nDO3;
	BOOL	m_nDO4;
	BOOL	m_nHOLD1;
	BOOL	m_nHOLD2;
	int		m_Offset_Direction;
	UINT	m_Offset_Setting;
	UINT	m_Offset_Step;
	int		m_Set_PD_Choice;
	//}}AFX_DATA


// Overrides
	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CPD2_Checkout)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:


	// Generated message map functions
	//{{AFX_MSG(CPD2_Checkout)
	afx_msg void OnWriteDac1();
	afx_msg void OnSelDac();
	afx_msg void OnSelExtInput();
	afx_msg void OnSelMadc1();
	afx_msg void OnSelMadc2();
	virtual BOOL OnInitDialog();
	afx_msg void OnWrFpgaDac();
	afx_msg void OnWrMultDacs();
	afx_msg void OnWrAdcToFile();
	afx_msg void OnStartNewFile();
	virtual void OnOK();
	afx_msg void OnTimer(UINT nIDEvent);
	afx_msg void OnResetFileSeq();
	afx_msg void OnD0Button1();
	afx_msg void OnD0Button2();
	afx_msg void OnD0Button3();
	afx_msg void OnD0Button4();
	afx_msg void OnHoldButton1();
	afx_msg void OnHoldButton2();
	afx_msg void OnWrOffset();
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Visual C++ will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_PD2_CHECKOUT_H__A8C3AFEF_76CA_4551_AC5A_75E1CCE41987__INCLUDED_)
