//---------------------------------------------------------------------------
// USBtestDlg.cpp:  Base test dialog implementation
// 
// 
// 
//---------------------------------------------------------------------------

// USBtestDlg.cpp : implementation file
#include "stdafx.h"
#include "USBtest.h"
#include "USBtestDlg.h"
//#include "ftd2xx.h"

#include <iostream>
#include <stdio.h>
#include <stdlib.h>
#include <string>

//#include "UM245R_Interface.h" 

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

//=============== GLOBAL VARIABLES ========================================
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
//REMOVED: int slide_pos;  //previously used in ThreadProc1(LPVOID param)
int running;


#define PROJECT_NAME "Phase_Detector_Module"


//=============== STANDARD MFC DIALOG BOX SUPPORT STUFF ===================
//~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~~
// CAboutDlg dialog used for App About
class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBtestDlg dialog

CUSBtestDlg::CUSBtestDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CUSBtestDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CUSBtestDlg)
	m_PortStatus = _T("");
	m_NumRecd = 0;
	m_128status = _T("");
	m_strFirst_Addr = _T("");
	m_nbytes = 0;
	m_szParamSetting0 = _T("");
	m_szParamReading0 = _T("");
	m_nParamBaseAddr = 0;
	m_szParamSetting1 = _T("");
	m_szParamSetting10 = _T("");
	m_szParamSetting11 = _T("");
	m_szParamSetting12 = _T("");
	m_szParamSetting13 = _T("");
	m_szParamSetting14 = _T("");
	m_szParamSetting15 = _T("");
	m_szParamSetting2 = _T("");
	m_szParamSetting3 = _T("");
	m_szParamSetting4 = _T("");
	m_szParamSetting5 = _T("");
	m_szParamSetting6 = _T("");
	m_szParamSetting7 = _T("");
	m_szParamSetting8 = _T("");
	m_szParamSetting9 = _T("");
	m_szParamReading1 = _T("");
	m_szParamReading10 = _T("");
	m_szParamReading11 = _T("");
	m_szParamReading12 = _T("");
	m_szParamReading13 = _T("");
	m_szParamReading14 = _T("");
	m_szParamReading15 = _T("");
	m_szParamReading2 = _T("");
	m_szParamReading3 = _T("");
	m_szParamReading4 = _T("");
	m_szParamReading5 = _T("");
	m_szParamReading6 = _T("");
	m_szParamReading7 = _T("");
	m_szParamReading8 = _T("");
	m_szParamReading9 = _T("");
	m_szParamFilename = _T("");
	m_szdescrp_0 = _T("");
	m_szdescrp_1 = _T("");
	m_szdescrp_10 = _T("");
	m_szdescrp_11 = _T("");
	m_szdescrp_12 = _T("");
	m_szdescrp_13 = _T("");
	m_szdescrp_14 = _T("");
	m_szdescrp_15 = _T("");
	m_szdescrp_2 = _T("");
	m_szdescrp_3 = _T("");
	m_szdescrp_6 = _T("");
	m_szdescrp_4 = _T("");
	m_szdescrp_5 = _T("");
	m_szdescrp_7 = _T("");
	m_szdescrp_8 = _T("");
	m_szdescrp_9 = _T("");
	m_szphysunits_0 = _T("");
	m_szphysunits_1 = _T("");
	m_szphysunits_10 = _T("");
	m_szphysunits_11 = _T("");
	m_szphysunits_12 = _T("");
	m_szphysunits_13 = _T("");
	m_szphysunits_14 = _T("");
	m_szphysunits_15 = _T("");
	m_szphysunits_2 = _T("");
	m_szphysunits_3 = _T("");
	m_szphysunits_4 = _T("");
	m_szphysunits_5 = _T("");
	m_szphysunits_6 = _T("");
	m_szphysunits_7 = _T("");
	m_szphysunits_8 = _T("");
	m_szphysunits_9 = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CUSBtestDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CUSBtestDlg)
	DDX_Control(pDX, IDC_LIST1, m_Received);
	DDX_Text(pDX, IDC_EDIT_PORT_STATUS, m_PortStatus);
	DDX_Text(pDX, IDC_EDIT_NUM_RECD, m_NumRecd);
	DDX_Text(pDX, IDC_EDIT_128_STATUS, m_128status);
	DDX_Text(pDX, IDC_FIRST_ADDR, m_strFirst_Addr);
	DDX_Text(pDX, IDC_N_BYTES, m_nbytes);
	DDX_Text(pDX, IDC_SETTING_0, m_szParamSetting0);
	DDX_Text(pDX, IDC_READING_0, m_szParamReading0);
	DDX_Text(pDX, IDC_PARAM_BASE, m_nParamBaseAddr);
	DDV_MinMaxLong(pDX, m_nParamBaseAddr, 0, 2147483647);
	DDX_Text(pDX, IDC_SETTING_1, m_szParamSetting1);
	DDX_Text(pDX, IDC_SETTING_10, m_szParamSetting10);
	DDX_Text(pDX, IDC_SETTING_11, m_szParamSetting11);
	DDX_Text(pDX, IDC_SETTING_12, m_szParamSetting12);
	DDX_Text(pDX, IDC_SETTING_13, m_szParamSetting13);
	DDX_Text(pDX, IDC_SETTING_14, m_szParamSetting14);
	DDX_Text(pDX, IDC_SETTING_15, m_szParamSetting15);
	DDX_Text(pDX, IDC_SETTING_2, m_szParamSetting2);
	DDX_Text(pDX, IDC_SETTING_3, m_szParamSetting3);
	DDX_Text(pDX, IDC_SETTING_4, m_szParamSetting4);
	DDX_Text(pDX, IDC_SETTING_5, m_szParamSetting5);
	DDX_Text(pDX, IDC_SETTING_6, m_szParamSetting6);
	DDX_Text(pDX, IDC_SETTING_7, m_szParamSetting7);
	DDX_Text(pDX, IDC_SETTING_8, m_szParamSetting8);
	DDX_Text(pDX, IDC_SETTING_9, m_szParamSetting9);
	DDX_Text(pDX, IDC_READING_1, m_szParamReading1);
	DDX_Text(pDX, IDC_READING_10, m_szParamReading10);
	DDX_Text(pDX, IDC_READING_11, m_szParamReading11);
	DDX_Text(pDX, IDC_READING_12, m_szParamReading12);
	DDX_Text(pDX, IDC_READING_13, m_szParamReading13);
	DDX_Text(pDX, IDC_READING_14, m_szParamReading14);
	DDX_Text(pDX, IDC_READING_15, m_szParamReading15);
	DDX_Text(pDX, IDC_READING_2, m_szParamReading2);
	DDX_Text(pDX, IDC_READING_3, m_szParamReading3);
	DDX_Text(pDX, IDC_READING_4, m_szParamReading4);
	DDX_Text(pDX, IDC_READING_5, m_szParamReading5);
	DDX_Text(pDX, IDC_READING_6, m_szParamReading6);
	DDX_Text(pDX, IDC_READING_7, m_szParamReading7);
	DDX_Text(pDX, IDC_READING_8, m_szParamReading8);
	DDX_Text(pDX, IDC_READING_9, m_szParamReading9);
	DDX_Text(pDX, IDC_ParamFilename, m_szParamFilename);
	DDX_Text(pDX, IDC_DESCRP_0, m_szdescrp_0);
	DDX_Text(pDX, IDC_DESCRP_1, m_szdescrp_1);
	DDX_Text(pDX, IDC_DESCRP_10, m_szdescrp_10);
	DDX_Text(pDX, IDC_DESCRP_11, m_szdescrp_11);
	DDX_Text(pDX, IDC_DESCRP_12, m_szdescrp_12);
	DDX_Text(pDX, IDC_DESCRP_13, m_szdescrp_13);
	DDX_Text(pDX, IDC_DESCRP_14, m_szdescrp_14);
	DDX_Text(pDX, IDC_DESCRP_15, m_szdescrp_15);
	DDX_Text(pDX, IDC_DESCRP_2, m_szdescrp_2);
	DDX_Text(pDX, IDC_DESCRP_3, m_szdescrp_3);
	DDX_Text(pDX, IDC_DESCRP_6, m_szdescrp_6);
	DDX_Text(pDX, IDC_DESCRP_4, m_szdescrp_4);
	DDX_Text(pDX, IDC_DESCRP_5, m_szdescrp_5);
	DDX_Text(pDX, IDC_DESCRP_7, m_szdescrp_7);
	DDX_Text(pDX, IDC_DESCRP_8, m_szdescrp_8);
	DDX_Text(pDX, IDC_DESCRP_9, m_szdescrp_9);
	DDX_Text(pDX, IDC_PHYSUNITS_0, m_szphysunits_0);
	DDX_Text(pDX, IDC_PHYSUNITS_1, m_szphysunits_1);
	DDX_Text(pDX, IDC_PHYSUNITS_10, m_szphysunits_10);
	DDX_Text(pDX, IDC_PHYSUNITS_11, m_szphysunits_11);
	DDX_Text(pDX, IDC_PHYSUNITS_12, m_szphysunits_12);
	DDX_Text(pDX, IDC_PHYSUNITS_13, m_szphysunits_13);
	DDX_Text(pDX, IDC_PHYSUNITS_14, m_szphysunits_14);
	DDX_Text(pDX, IDC_PHYSUNITS_15, m_szphysunits_15);
	DDX_Text(pDX, IDC_PHYSUNITS_2, m_szphysunits_2);
	DDX_Text(pDX, IDC_PHYSUNITS_3, m_szphysunits_3);
	DDX_Text(pDX, IDC_PHYSUNITS_4, m_szphysunits_4);
	DDX_Text(pDX, IDC_PHYSUNITS_5, m_szphysunits_5);
	DDX_Text(pDX, IDC_PHYSUNITS_6, m_szphysunits_6);
	DDX_Text(pDX, IDC_PHYSUNITS_7, m_szphysunits_7);
	DDX_Text(pDX, IDC_PHYSUNITS_8, m_szphysunits_8);
	DDX_Text(pDX, IDC_PHYSUNITS_9, m_szphysunits_9);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CUSBtestDlg, CDialog)
	//{{AFX_MSG_MAP(CUSBtestDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_BUTTON_CLEAR, OnButtonClear)
	ON_BN_CLICKED(IDC_BUTTON_NEW_READ, OnButtonNewRead)
	ON_EN_CHANGE(IDC_FIRST_ADDR, OnChangeFirstAddr)
	ON_EN_CHANGE(IDC_N_BYTES, OnChangeNBytes)
	ON_BN_CLICKED(IDC_BUTTON_NEW_WRITE, OnButtonNewWrite)
	ON_BN_CLICKED(IDC_PARAM_UPDATE, OnParamUpdate)
	ON_EN_KILLFOCUS(IDC_ParamFilename, OnKillfocusParamFilename)
	ON_BN_CLICKED(IDC_TEST_BUTTON1, OnTestButton1)
	ON_BN_CLICKED(IDC_SAVE_PARAM, OnSaveParam)
	ON_BN_CLICKED(IDC_LOAD_PARAM, OnLoadParam)
	ON_BN_CLICKED(IDC_OPEN_USB, OnOpenUsb)
	ON_BN_CLICKED(IDC_OPEN_PD2_CHKOUT, OnOpenPd2Checkout)
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CUSBtestDlg message handlers



void CUSBtestDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

// If you add a minimize button to your dialog, you will need the code below
//  to draw the icon.  For MFC applications using the document/view model,
//  this is automatically done for you by the framework.

void CUSBtestDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}

}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CUSBtestDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}


//*******************************************************************************
//*******************************************************************************
//************  THIS IS THE START OF THE GOOD STUFF  ****************************
//*******************************************************************************
//*******************************************************************************
BOOL CUSBtestDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.
	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon
	
	//------------- extra initialization here ----------------------------
	buttons(OFF);     //turn em off till a port is active
	mparams_ready=0;  // status indicator
	m_file_loaded=0;  // status indicator
	szParamFilename = " ";
	//--------------------------------------------------------------------
	
	//------------- Communications Timer ------------------------------------
	// This code is setup to receive Timer Windows messages.
	// See function CUSBtestDlg::OnTimer(UINT nIDEvent)"

	SetTimer(15, 100, NULL);//check for new USB data in the buffer every 100mS

	//--------------------------------------------------------------------

	//-------------- Buffer Read and Write Test Controls ----------------------
	// First_Address and NumBytes are control parameters used by the very basic
	// "Buffer Read Test" and "Buffer Write Test" function buttons.  
	// First Address is the address of the first memory location in our target 
	// module to read or write via the USB port.  NumBytes is the number of
	// bytes to be read of written.  
		m_strFirst_Addr  = AfxGetApp()->GetProfileString("MyUSBTestAp", "FirstAddress", "20000");
		m_nbytes         = AfxGetApp()->GetProfileInt   ("MyUSBTestAp", "NumBytes", 12);

	//-------------------------------------------------------------------------

	//-------------- Parameter Filename Edit Box Setting ----------------------
	// This filename has been fixed to "param_file_2.txt" for now.

		m_szParamFilename  = AfxGetApp()->GetProfileString(PROJECT_NAME, "ParamFilename", "param_file_2.txt");
		//m_szParamFilename  = "param_file_2.txt";
		szParamFilename	   = m_szParamFilename; // szParamFilename is set to contents of the edit box input.
	//---------------------------------------------------------------------------

	//-------------- Initialize the Parameter Objects ------------------------
	// Parameter.h and Parameter.cpp define a CParameter object.  
	// Objects of this type have been declared in USBtestDlg.h.
	
		Initialize_Parameter_Objects(); //Initialize the CParameter Objects
	//------------------------------------------------------------------------

		UpdateData(FALSE);

	//------------- Create the UM245R Object and Open the USB driver ----------
		pUM245R = new UM245R_Interface; 
		Initialize_USB_Interface();
	//-------------------------------------------------------------------------


	UpdateData(FALSE);
	UpdateWindow();
	return TRUE;  // return TRUE  unless you set the focus to a control
}


//****************************************************************************************
void CUSBtestDlg::OnOpenUsb() 
{
	pUM245R->Close();
	m_file_loaded = 0;
	Initialize_USB_Interface(); 
	if(m_file_loaded > 0) 
		SaveModuleParams(); // See about saving module parameters to file or not

}

//****************************************************************************************
void CUSBtestDlg::Initialize_USB_Interface()  
{
	pUM245R->Initialize_USB_Interface();
	m_PortStatus = pUM245R->Get_USB_Status();
	m_file_loaded = LoadParamsFromFile2(szParamFilename); //first get setup from file, then

	if(m_PortStatus != _T("USB ready.")) 
	{
		pUM245R->DoModal();
		m_PortStatus = pUM245R->Get_USB_Status();
	}

	if(m_PortStatus == _T("USB ready."))
	{
		GetParamFromModule(); // Get the parameters from the running module
	}
	UpdateData(FALSE);
	UpdateWindow();

}


//**********************************************************************************
void CUSBtestDlg::OnOK()  // a.k.a. the EXIT Button
{
//	int i;
//	char msg[40];
	//terminate the thread
	running=0;

	delete pUM245R;
	CDialog::OnOK();	

}

//*******************************************************************
// This timer will catch the USB if it goes away.  It is setup in the
// Initialize_Dialog routine using "SetTimer(15, 100, NULL);"
//
// This routine will grab data it finds in the USB receive buffer unless
// the bus_busy flag is set >0.  The bus_busy is set by routines that are
// called and expected to finish before any other USB transactions are
// attempted.

void CUSBtestDlg::OnTimer(UINT nIDEvent) 
{
	unsigned char rx[600];
	DWORD ret_bytes;
	DWORD bytes_in_buf;
	FT_STATUS status;

	if(!pUM245R->board_present)
		return;

	if(pUM245R->bus_busy)	//don't interfere with another test
		return;

	status = pUM245R->GetQueueStatus(&bytes_in_buf);
	if(status != FT_OK)
	{
		UpdateData(TRUE);
		m_PortStatus = _T("DLP-USB not open.");
		pUM245R->Close();
		pUM245R->board_present=0;
		UpdateData(FALSE);
		UpdateWindow();

		bytes_in_buf = 0;
	}

	if(bytes_in_buf)
	{
		status = pUM245R->Read(rx, bytes_in_buf<600 ? bytes_in_buf : 600, &ret_bytes);
		if((status == FT_OK) || ((status == FT_IO_ERROR) && (ret_bytes > 0)) /* Read timeout */)
		{
			if(ret_bytes)
			{
				CString str;
				UpdateData(TRUE);
				for(DWORD x=0; x<ret_bytes; x++)
				{
					m_NumRecd++;
					str.Format("%d  0x%.2X", rx[x], rx[x]);
					m_Received.AddString(str);		
				}
			}
		}

		UpdateData(FALSE);
		UpdateWindow();
	}

	CDialog::OnTimer(nIDEvent);
}

//****************************************************************************
BOOL CUSBtestDlg::OnCommand(WPARAM wParam, LPARAM lParam) //disable the ESC key
{
	if(wParam==2) return FALSE;
	return CDialog::OnCommand(wParam, lParam);
}


//*******************************************************************
void CUSBtestDlg::OnButtonClear() 
{
		UpdateData(TRUE);
		m_NumRecd=0;
		m_Received.ResetContent();
		UpdateData(FALSE);
		UpdateWindow();
}

//****************************************************************************************
void CUSBtestDlg::OnChangeFirstAddr() 
{
	CWinApp* pApp = AfxGetApp();  
	//write the new setup to the registry
	UpdateData(TRUE);
	pApp->WriteProfileString("MyUSBTestAp", "FirstAddress", m_strFirst_Addr);

	UpdateData(FALSE);
	UpdateWindow();
}

//****************************************************************************************
void CUSBtestDlg::OnChangeNBytes() 
{
	CWinApp* pApp = AfxGetApp();  
	//write the new setup to the registry
	UpdateData(TRUE);
	pApp->WriteProfileInt("MyUSBTestAp", "NumBytes", m_nbytes);

	UpdateData(FALSE);
	UpdateWindow();
	
}

void CUSBtestDlg::OnButtonNewRead() 
{
	unsigned char tx[5], rx[1000];
	long int	first_addr;
	int			mode;
	long int	wait_count=0;
	char		msg[80];

	DWORD ret_bytes, bytes_in_buf;
	FT_STATUS status;

	if(!pUM245R->board_present)
		return;

	UpdateData(TRUE);
	m_128status = _T("Doing New Read...");
	UpdateData(FALSE);
	UpdateWindow();

	pUM245R->bus_busy=1;
	buttons(OFF);

	sscanf (m_strFirst_Addr,"%x",&first_addr);

	if(sscanf (m_strFirst_Addr,"%x",&first_addr) > 0)
	{
		// Setup Header //full address mode read 
		mode  = 0;
		tx[0] = (mode << 5) + ((first_addr & 0x1F0000) >> 16);
		tx[1] = (first_addr & 0x00FF00) >> 8;
		tx[2] = (first_addr & 0x0000FF);
		tx[3] = (m_nbytes   & 0xFF00) >> 8;
		tx[4] = (m_nbytes   & 0x00FF);

		pUM245R->Write(tx, 5, &ret_bytes);
	}
	else
	{
		AfxMessageBox("First Address not set"); 
	}

	//----------------------------------------------------------------------------
	// Get requested data from the receiver
	OnButtonClear(); // clear the Data Received window
	while(bytes_in_buf != m_nbytes)
	{ 
		pUM245R->GetQueueStatus(&bytes_in_buf);	
		if(wait_count++ > 0xFFFFF)
		{
			UpdateData(TRUE);
			sprintf(msg,"* TIMED OUT Bytes = %d *",bytes_in_buf);
			m_128status = _T(msg);
			UpdateData(FALSE);
		}
		
	}

	if(bytes_in_buf)
	{
		status = pUM245R->Read(rx, bytes_in_buf<1000 ? bytes_in_buf : 1000, &ret_bytes);
		if((status == FT_OK) || ((status == FT_IO_ERROR) && (ret_bytes > 0)) /* Read timeout */)
		{
			if(ret_bytes)
			{
				CString str;
				UpdateData(TRUE);
				for(DWORD x=0; x<ret_bytes; x++)
				{
					m_NumRecd++;
					str.Format("Received: %d  0x%.2X", rx[x], rx[x]);
					m_Received.AddString(str);		
				}
				UpdateData(FALSE);
			}
		}
	}

	pUM245R->bus_busy=0;
	UpdateData(TRUE);
	m_128status = _T("Done");
	UpdateData(FALSE);
	UpdateWindow();

	buttons(ON);	
}


void CUSBtestDlg::OnButtonNewWrite() 
{
	unsigned char tx[13]; // 5 bytes hdr + 8 bytes data
	long int first_addr;
	int mode;

	DWORD ret_bytes;

	if(!pUM245R->board_present)
		return;

	UpdateData(TRUE);
	m_128status = _T("Doing New Write...");
	UpdateData(FALSE);
	UpdateWindow();

	pUM245R->bus_busy=1;
	buttons(OFF);

	sscanf (m_strFirst_Addr,"%x",&first_addr);

	if(sscanf (m_strFirst_Addr,"%x",&first_addr) > 0)
	{
		// Setup Header //full address mode read 
		mode  = 1;
		tx[0] = (mode << 5) + ((first_addr & 0x1F0000) >> 16);
		tx[1] = (first_addr & 0x00FF00) >> 8;
		tx[2] = (first_addr & 0x0000FF);
		tx[3] = 0x00; //(m_nbytes   & 0xFF00) >> 8;
		tx[4] = 0x08; //(m_nbytes   & 0x00FF);

		// Setup Test Data
		tx[5] = 0xA3;
		tx[6] = 0x43;
		tx[7] = 0x65;
		tx[8] = 0x87;

		tx[9] = 0xFE;
		tx[10]= 0xDC;
		tx[11]= 0xBA;
		tx[12]= 0x98;

		pUM245R->Write(tx, 13, &ret_bytes);
	}
	else
	{
		AfxMessageBox("First Address not set"); 
	}

	pUM245R->bus_busy=0;
	UpdateData(TRUE);
	m_128status = _T("Done");
	UpdateData(FALSE);
	UpdateWindow();

	buttons(ON);		
}

//===========================================================
// Initialize_Parameter_Objects:
// 
void CUSBtestDlg::Initialize_Parameter_Objects()
{
	Number_of_Params_Used = 12;
	Prm[0].setting_ptr = &m_szParamSetting0;
	Prm[1].setting_ptr = &m_szParamSetting1;
	Prm[2].setting_ptr = &m_szParamSetting2;
	Prm[3].setting_ptr = &m_szParamSetting3;
	Prm[4].setting_ptr = &m_szParamSetting4;
	Prm[5].setting_ptr = &m_szParamSetting5;
	Prm[6].setting_ptr = &m_szParamSetting6;
	Prm[7].setting_ptr = &m_szParamSetting7;
	Prm[8].setting_ptr = &m_szParamSetting8;
	Prm[9].setting_ptr = &m_szParamSetting9;
	Prm[10].setting_ptr = &m_szParamSetting10;
	Prm[11].setting_ptr = &m_szParamSetting11; 

	Prm[0].reading_ptr = &m_szParamReading0; 
	Prm[1].reading_ptr = &m_szParamReading1;
	Prm[2].reading_ptr = &m_szParamReading2;
	Prm[3].reading_ptr = &m_szParamReading3;
	Prm[4].reading_ptr = &m_szParamReading4;
	Prm[5].reading_ptr = &m_szParamReading5;
	Prm[6].reading_ptr = &m_szParamReading6;
	Prm[7].reading_ptr = &m_szParamReading7;
	Prm[8].reading_ptr = &m_szParamReading8;
	Prm[9].reading_ptr = &m_szParamReading9;
	Prm[10].reading_ptr = &m_szParamReading10; 
	Prm[11].reading_ptr = &m_szParamReading11; 

	Prm[0].physunits_ptr = &m_szphysunits_0; 
	Prm[1].physunits_ptr = &m_szphysunits_1;
	Prm[2].physunits_ptr = &m_szphysunits_2;
	Prm[3].physunits_ptr = &m_szphysunits_3;
	Prm[4].physunits_ptr = &m_szphysunits_4;
	Prm[5].physunits_ptr = &m_szphysunits_5;
	Prm[6].physunits_ptr = &m_szphysunits_6;
	Prm[7].physunits_ptr = &m_szphysunits_7;
	Prm[8].physunits_ptr = &m_szphysunits_8;
	Prm[9].physunits_ptr = &m_szphysunits_9;
	Prm[10].physunits_ptr = &m_szphysunits_10; 
	Prm[11].physunits_ptr = &m_szphysunits_11; 

	// initialize the unused paramters
	m_szParamSetting12 = "";
	m_szParamSetting13 = "";
	m_szParamSetting14 = "";
	m_szParamSetting15 = "";

	m_szParamReading12 = "";
	m_szParamReading13 = "";
	m_szParamReading14 = "";
	m_szParamReading15 = "";

	m_szphysunits_12 = "";
	m_szphysunits_13 = "";
	m_szphysunits_14 = "";
	m_szphysunits_15 = "";

	mparams_ready = 1;
}

void CUSBtestDlg::GetParamFromModule()
{
	int i;
	CString szparam;

	if(mparams_ready == 1) 
	{
		for(i=0;i<12;i++)
		{
			  szparam  = pUM245R->read_param_str(i,1);
			*(Prm[i].reading_ptr) = szparam;
			*(Prm[i].setting_ptr) = szparam;

			strcpy(Prm[i].szvalue, (LPCTSTR) szparam);   
		}
		UpdateData(FALSE);

	}
	else 
	{
		AfxMessageBox("CODE ERROR : GetParamFromModule() PARAMS NOT INITIALIZED");
	}

}

//=====================================================================================
void CUSBtestDlg::OnParamUpdate() 
{
	ParamUpdate();
} 

void CUSBtestDlg::ParamUpdate()
{
	UpdateData(TRUE);

	m_szParamReading0  = UpdateParameter(0 , m_szParamSetting0 , m_szParamReading0 );	
	m_szParamReading1  = UpdateParameter(1 , m_szParamSetting1 , m_szParamReading1 );	
	m_szParamReading2  = UpdateParameter(2 , m_szParamSetting2 , m_szParamReading2 );	
	m_szParamReading3  = UpdateParameter(3 , m_szParamSetting3 , m_szParamReading3 );	
	m_szParamReading4  = UpdateParameter(4 , m_szParamSetting4 , m_szParamReading4 );	
	m_szParamReading5  = UpdateParameter(5 , m_szParamSetting5 , m_szParamReading5 );	
	m_szParamReading6  = UpdateParameter(6 , m_szParamSetting6 , m_szParamReading6 );	
	m_szParamReading7  = UpdateParameter(7 , m_szParamSetting7 , m_szParamReading7 );	

	m_szParamReading8  = UpdateParameter(8 , m_szParamSetting8 , m_szParamReading8 );	
	m_szParamReading9  = UpdateParameter(9 , m_szParamSetting9 , m_szParamReading9 );	
	m_szParamReading10 = UpdateParameter(10, m_szParamSetting10, m_szParamReading10);	
	m_szParamReading11 = UpdateParameter(11, m_szParamSetting11, m_szParamReading11);	
	m_szParamReading12 = UpdateParameter(12, m_szParamSetting12, m_szParamReading12);	
	m_szParamReading13 = UpdateParameter(13, m_szParamSetting13, m_szParamReading13);	
	m_szParamReading14 = UpdateParameter(14, m_szParamSetting14, m_szParamReading14);	
	m_szParamReading15 = UpdateParameter(15, m_szParamSetting15, m_szParamReading15);	
	
		
	UpdateData(FALSE);
	UpdateWindow();
	SaveParamsToFile(szParamFilename);

}


CString CUSBtestDlg::UpdateParameter(long int index, CString setting, CString reading)
{
	CString return_reading;
	
	if(index >= Number_of_Params_Used) //this was set in Initialize_Parameter_Objects()
	{
		return_reading = "";
		return return_reading;
	}

	if(setting != reading)
	{
		pUM245R->write_param_str(index, setting);		
	}

	if (setting.Find('x') > 0 )
		 return_reading = pUM245R->read_param_str(index, 1); // the 1 says return number as hex
	else return_reading = pUM245R->read_param_str(index, 0);

	strcpy(Prm[index].szvalue, (LPCTSTR) return_reading);
	Compute_PhysUnits_Param(index);

	return return_reading;
}
//=====================================================================================

void CUSBtestDlg::OnKillfocusParamFilename() 
{
	int file_loaded=0;

	UpdateData(TRUE);
	if ( szParamFilename != m_szParamFilename)
	{
		Param_File_Dialog dlg;
		dlg.m_new_filename = m_szParamFilename;
		dlg.DoModal();
		switch(dlg.m_nchoice)
		{
		case 0: 
			m_szParamFilename = szParamFilename; // set to previous value
			UpdateData(FALSE);
			break;
		case 1:
			AfxGetApp()->WriteProfileString(PROJECT_NAME, "ParamFilename", m_szParamFilename);
			szParamFilename = m_szParamFilename; // szParamFilename is set to contents of the edit box input.
			file_loaded = LoadParamsFromFile2(szParamFilename);
			UpdateData(FALSE);
			if(file_loaded > 0) OnParamUpdate();
			break;
		case 2:
			AfxGetApp()->WriteProfileString(PROJECT_NAME, "ParamFilename", m_szParamFilename);
			szParamFilename = m_szParamFilename; // szParamFilename is set to contents of the edit box input.
			SaveParamsToFile(szParamFilename);
			break;
		default:
			m_szParamFilename = szParamFilename; // set to previous value
			UpdateData(FALSE);
			break;
		}
	} // end if
}

void CUSBtestDlg::SaveModuleParams()
{
	int n_response;

	UpdateData(TRUE);
	CSaveParamDlg dlg;
	dlg.m_Filename = m_szParamFilename;
	n_response = dlg.DoModal();

	if(n_response == IDOK)
	{
		AfxGetApp()->WriteProfileString(PROJECT_NAME, "ParamFilename", m_szParamFilename);
		szParamFilename = m_szParamFilename; // szParamFilename is set to contents of the edit box input.
		SaveParamsToFile(szParamFilename);
	}
}

//====================================================================================
void CUSBtestDlg::OnLoadParam() 
{
	UpdateData(TRUE);
	int file_loaded = LoadParamsFromFile2(szParamFilename);
	UpdateData(FALSE);
	if(file_loaded > 0) ParamUpdate();
	
}

int CUSBtestDlg::LoadParamsFromFile2(CString filename)
{
	char msg[80];

	if(mparams_ready == 1) 
	{
	GetParamsFromFile(filename);
	
	sprintf(msg,"%s, %s", Prm[0].szunits,  Prm[0].szdescription);  m_szdescrp_0  = msg;	
	sprintf(msg,"%s, %s", Prm[1].szunits,  Prm[1].szdescription);  m_szdescrp_1  = msg;
	sprintf(msg,"%s, %s", Prm[2].szunits,  Prm[2].szdescription);  m_szdescrp_2  = msg;	
	sprintf(msg,"%s, %s", Prm[3].szunits,  Prm[3].szdescription);  m_szdescrp_3  = msg;	
	sprintf(msg,"%s, %s", Prm[4].szunits,  Prm[4].szdescription);  m_szdescrp_4  = msg;	
	sprintf(msg,"%s, %s", Prm[5].szunits,  Prm[5].szdescription);  m_szdescrp_5  = msg;	
	sprintf(msg,"%s, %s", Prm[6].szunits,  Prm[6].szdescription);  m_szdescrp_6  = msg;	
	sprintf(msg,"%s, %s", Prm[7].szunits,  Prm[7].szdescription);  m_szdescrp_7  = msg;	
	sprintf(msg,"%s, %s", Prm[8].szunits,  Prm[8].szdescription);  m_szdescrp_8  = msg;	
	sprintf(msg,"%s, %s", Prm[9].szunits,  Prm[9].szdescription);  m_szdescrp_9  = msg;	
	sprintf(msg,"%s, %s", Prm[10].szunits, Prm[10].szdescription); m_szdescrp_10 = msg;	
	sprintf(msg,"%s, %s", Prm[11].szunits, Prm[11].szdescription); m_szdescrp_11 = msg;
 	
	// initialize the unused paramters
	m_szdescrp_12 = "reserved";
	m_szdescrp_13 = "reserved";
	m_szdescrp_14 = "reserved";
	m_szdescrp_15 = "reserved";

	UpdateData(FALSE);
	return 1;
	}
	else 
	{
		AfxMessageBox("CODE ERROR : PARAMS NOT INITIALIZED");
		return -1;
	}

}

int CUSBtestDlg::GetParamsFromFile(CString filename)
{
	FILE *fp;
	CString fullfilename;
	char s[80];
	char s2[80];
	char* stok;
	int i;
//	char msg[80];

	fullfilename = filename;

	fp=fopen(fullfilename, "r");

	if ( fp == NULL) 
	{
		sprintf(s,"Param File not in same directory as this App's exe");
		AfxMessageBox(s);
		return -1;
	}

	fseek( fp, 0L, SEEK_SET );

	//-------------------------------------------- get file header
	if(fgets(s,80,fp ) == NULL) {fclose(fp); return 1;}
	AfxMessageBox(s);

	for(i=0; i<12; i++) 
	{
		if(fgets(s,80,fp ) == NULL) {fclose(fp); return 1;}		
		s[strcspn (s,"\n")] = '\0'; // Remove the newline

		strcpy(s2,s);
		stok = strtok(s2,","); 
		if(stok == NULL)  {AfxMessageBox("stok was NULL"); fclose(fp); return 1;}
		
		while(isspace(*stok)) stok++; //remove leading spaces
		if(*stok != 0)	
		{
		// --------------------------- get parameter value
			stok = strtok(s,","); 
			while(isspace(*stok)) stok++; //remove leading spaces
			if(*stok == 0)	strcpy(Prm[i].szvalue, "0x0000");
			else			strcpy(Prm[i].szvalue, stok);

	//sprintf(msg,"length = %u, string>%s<", strlen(stok), Prm[i].szvalue);
	//AfxMessageBox(msg);

		// --------------------------- get parameter scale factor
			stok = strtok(NULL,","); while(isspace(*stok)) stok++; //remove leading spaces

			if(*stok == 0)	Prm[i].scale = 1.0;			
			else			Prm[i].scale = atof(stok);
				
	//sprintf(msg,"scale = %f",Prm[i].scale);
	//AfxMessageBox(msg);

		// --------------------------- get parameter offset
			stok = strtok(NULL,","); while(isspace(*stok)) stok++; //remove leading spaces
			if(*stok == 0)	Prm[i].offset = 0.0;			
			else			Prm[i].offset = atof(stok);
				
	//sprintf(msg,"Offset = %f",ptrPrm[i]->offset);
	//AfxMessageBox(msg);

		// --------------------------- get parameter units
			stok = strtok(NULL,","); while(isspace(*stok)) stok++; //remove leading spaces
			if(*stok == 0)	strcpy(Prm[i].szunits, "--");			
			else			strcpy(Prm[i].szunits, stok);
				
	//sprintf(msg,"length = %u, Units = %s", strlen(stok), Prm[i].szunits);
	//AfxMessageBox(msg);

		// --------------------------- get parameter description
			stok = strtok(NULL,","); while(isspace(*stok)) stok++; //remove leading spaces
			if(*stok == 0)	strcpy(Prm[i].szdescription, "--");			
			else			strcpy(Prm[i].szdescription, stok);
				
	//sprintf(msg,"i = %d, length = %u, %s", i, strlen(stok), Prm[i].szdescription);
	//AfxMessageBox(msg);
			*(Prm[i].setting_ptr) = Prm[i].szvalue; 

			Compute_PhysUnits_Param(i);

		} // end if

	}

	fclose(fp); return 1;
}

//========================================================================================
void CUSBtestDlg::Compute_PhysUnits_Param(int i)
{
	double fval;
	unsigned long int ulval;
	char szfval[20];

	ulval = strtoul ( Prm[i].szvalue, NULL, 16 );
	fval = (ulval + Prm[i].offset) * Prm[i].scale;

//sprintf(msg,"%+10.4f = (%lu + %+10.4f)  *  %+10.4f",fval, ulval, Prm[i].offset, Prm[i].scale);
//AfxMessageBox(msg);
	if     (fval < 100.0000) sprintf(szfval,"%+10.4f", fval);
	else if(fval < 1000.000) sprintf(szfval,"%+10.3f", fval);
	else if(fval < 10000.00) sprintf(szfval,"%+10.2f", fval);
	else					 sprintf(szfval,"%+10.1f", fval);
	*(Prm[i].physunits_ptr) = szfval;

}

//========================================================================================
void CUSBtestDlg::OnSaveParam() 
{
	SaveParamsToFile(szParamFilename);	
}


void CUSBtestDlg::SaveParamsToFile(CString filename)
{
	FILE *fp;
	CString fullfilename;
	int i;

	fullfilename = filename;

	fp = fopen(fullfilename, "w");
	if (fp == NULL) {AfxMessageBox("could not open file to save parameters"); return;}

	fprintf(fp,"Dual Phase Detector for MI Phase Lock\n");

	for(i=0;i<12;i++)
	{
		fprintf(fp,"%12s, %+10.4f, %+10.4f, %6s, %s\n", 
			*(Prm[i].setting_ptr), Prm[i].scale, 
			  Prm[i].offset, Prm[i].szunits, Prm[i].szdescription);
	}

	fclose(fp); return;

}

//========================================================================================
void CUSBtestDlg::DisplayPhysUnits()
{
	
	UpdateData(TRUE);



	UpdateData(FALSE);

}

void CUSBtestDlg::OnTestButton1() 
{
	CString *sptr[2];
	CString my_cstring;
	char msg[80];

	UpdateData(TRUE);

	sptr[1] = &m_szParamSetting2;
	my_cstring = *sptr[1];

	sprintf(msg," my_cstring = %s", my_cstring);
	AfxMessageBox(msg);


	UpdateData(FALSE);


}







//****************************************************************************
/*
UINT ThreadProc1(LPVOID param)//count up thread
{
	//typecast the handle to the parent window
//	CUSBtestDlg *pMyHndl = (CUSBtestDlg *)param;
	UM245R *pMyHndl = (UM245R *)param;

	unsigned char tx[65], cnt=0;
	DWORD ret_bytes;
	FT_STATUS status;

	while(running)
	{
		//sleep for requested duration
		if(slide_pos <500)
		{
			Sleep(500-slide_pos);
			//send binary count to the LEDs
			tx[0]=0x40;
			tx[0] |= (cnt & 0x0f);
			
			status = pMyHndl->Write(tx, 1, &ret_bytes);			
			if((status != FT_OK) && (status != FT_IO_ERROR))//if error during write then terminate thread
				running=0;

			cnt++;	
		}
		else
		{
			cnt=0;

			for(int t=0; t<64; t++)
			{
				tx[t]=0x40;
				tx[t] |= (cnt++ & 0x0f);
			}

			status = pMyHndl->Write(tx, 64, &ret_bytes);
			if((status != FT_OK) && (status != FT_IO_ERROR))//if error during write (other than timeout) then terminate thread
				running=0;

			Sleep(1);
		}
	}

	return 0;
}

*/



//***********************************************************************
void CUSBtestDlg::buttons(int onoff)
{
	if(onoff == OFF)
	{
//		GetDlgItem(IDC_BUTTON_SEND_RECDIS)->EnableWindow(FALSE);
//		GetDlgItem(IDC_BUTTON_SEND128_ECHO)->EnableWindow(FALSE);
//		GetDlgItem(IDC_BUTTON_BLINK_ON)->EnableWindow(FALSE);
//		GetDlgItem(IDC_BUTTON_BLINK_OFF)->EnableWindow(FALSE);
//		GetDlgItem(IDC_SLIDER_WRITE_RATE)->EnableWindow(FALSE);
	}

	if(onoff == ON)
	{
//		GetDlgItem(IDC_BUTTON_SEND_RECDIS)->EnableWindow(TRUE);
//		GetDlgItem(IDC_BUTTON_SEND128_ECHO)->EnableWindow(TRUE);
//		GetDlgItem(IDC_BUTTON_BLINK_ON)->EnableWindow(TRUE);
//		GetDlgItem(IDC_BUTTON_BLINK_OFF)->EnableWindow(TRUE);
//		GetDlgItem(IDC_SLIDER_WRITE_RATE)->EnableWindow(TRUE);

	}
}



void CUSBtestDlg::OnOpenPd2Checkout() 
{
	UpdateData(TRUE);
	CSaveRequest dlg = new CSaveRequest();
	if(dlg.DoModal() == IDOK)
	{

		pUM245R->write_param_bit(7, 10, 1);

		AfxMessageBox("Saved Parameters to EEPROM");

		pUM245R->write_param_bit(7, 10, 0);

	}
	else
	{
		// ended with cancel
	}

	CPD2_Checkout dlg2 = new CPD2_Checkout(this);
	dlg2.pUSB = pUM245R;

	if (dlg2.DoModal() == IDOK)
	{

		// ended with OK
	}
	else
	{
		// ended with cancel
	}

	
}

